Foreman - Bug #29110

Uploading facts from Debian 10 (Buster) nodes returns error message from Foreman
02/21/2020 08:58 AM - Martin Altke

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Facts
Target version: 2.01
Difficulty: Fixed in Releases: 1.24.3,2.0.1,2.1.0
Triaged: No Found in Releases: 1.24.2
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7482,
https://github.com/theforeman/foreman/p
ull/7631,
https://github.com/theforeman/foreman/p
ull/7632
Description

Running the fact upload on a Puppet master:
/opt/puppetlabs/puppet/bin/ruby /etc/puppetlabs/puppet/foreman_facts.rb —--push-facts-parallel
Results in error messages from Debian Buster systems:

During the fact upload the server responded with: 500 Internal Server Error. Error is ignored
and the execution continues.

{
"error": {"message":"Validation failed: Description has already been taken, Title has alread
y been taken"}

}
No further log output available.

Any help appretiated.

Associated revisions

Revision 5d61c18f - 05/03/2020 07:25 AM - Lukas Zapletal
Fixes #29110 - updated fact parser to handle v3 debian OS (#7482)

History

#1 - 02/24/2020 09:20 AM - Lukas Zapletal

Smells like race condition. Try without --push-facts-parallel and also indlude full backtrace of the error.

#2 - 02/25/2020 08:33 AM - Robert Flechtner

I ran into the same issue. When Debian 10 facts are uploaded only the OS' major version is set in the title and description fields of the
operatingsystems table. This results in those fields always being set to "Debian 10" independent of the minor version fact, which is detected properly
though and written to the minor column of the table. This means that if Debian 10.0 facts have been uploaded before, the upload of Debian 10.1 facts
will result in the Description has already been taken, Title has already been taken error message.

#3 - 02/25/2020 04:52 PM - Lukas Zapletal

Sounds like a bug, here is the relevant code can you investigate? It should match minor and major versions:

https://github.com/theforeman/foreman/blob/develop/app/services/puppet_fact parser.rb#l 4-L40

#4 - 02/27/2020 02:14 PM - Lukas Zapletal

Relevant discussion: https:/community.theforeman.org/t/facts-upload-failed-description-has-already-been-taken/17573
https://github.com/theforeman/foreman/blob/develop/app/services/puppet_fact_parser.rb#L4-L40
https://community.theforeman.org/t/facts-upload-failed-description-has-already-been-taken/17573

#5 - 02/27/2020 03:19 PM - Ewoud Kohl van Wijngaarden

Perhaps the core issue is that we don't deal with the change in Debian? Since Debian 7 the use of minor versions was dropped. Previously, Debian
6.0 and Debian 6.1 were seen as separate releases. With Debian 7, 7.0 an 7.1 are the same release. The .x is more like a .z in that sense. You can
see this in the facter output as well:

$ facter os
{
architecture => "amdo64",
distro => {
codename => "buster",
description => "Debian GNU/Linux 10 (buster)",
id => "Debian",
release => {
full => "10",
major => "10"
}
}I
family => "Debian",
hardware => "x86_64",
name => "Debian",
release => {
full => "10.3",
major => "10",
minor => "3"
}I
selinux => {
enabled => false
}
}

Foreman still tries to parse the legacy facts itself and be smarter.
From Debian 9:

# facter lsbdistrelease

9.11

$ facter lsbdistrelease
10

| suspect the following code isn't smart enough about that.
major, minor = orel.split('."', 2)

major = major.to_s.gsub(/\D/, '")
minor = minor.to_s.gsub(/[~\d\.]1/, '")

#6 - 03/03/2020 09:21 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Lukas Zapletal

- Pull request https://github.com/theforeman/foreman/pull/7482 added

#7 - 03/03/2020 09:25 AM - Lukas Zapletal

- Target version set to 2.0.1

Requesting 2.0 backport, multiple users have reported this.

#8 - 03/16/2020 08:50 AM - Martin Alfke

Lukas Zapletal wrote:

Requesting 2.0 backport, multiple users have reported this.

Can we also receive a backport to 1.xx?

#9 - 05/03/2020 07:25 AM - The Foreman Bot
- Fixed in Releases 2.1.0 added

05/12/2024 2/3



#10 - 05/03/2020 08:01 AM - Anonymous
- Status changed from Ready For Testing to Closed

Applied in changeset 5d61c18fa7bdee314ac146ba6b35353¢c16c63b37.

#11 - 05/04/2020 02:01 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/7631 added

#12 - 05/04/2020 02:05 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/7632 added

#13 - 05/04/2020 02:06 PM - Lukas Zapletal
- Fixed in Releases deleted (2.1.0)

Cherry picks for 2.0 and 1.24 are ready. The last call is on our release manager tho.

#14 - 05/06/2020 08:00 AM - Tomer Brisker
- Fixed in Releases 1.24.3, 2.0.1, 2.1.0 added

#15 - 05/14/2020 07:14 AM - Amit Upadhye

- Category set to Facts
